Index: /trunk/kBuild/header.kmk
===================================================================
--- /trunk/kBuild/header.kmk	(revision 1417)
+++ /trunk/kBuild/header.kmk	(revision 1418)
@@ -838,4 +838,15 @@
    export KBUILD_VERBOSE := 2
   endif
+ endif
+endif
+
+
+#
+# Legacy variable translation.
+# These will be eliminated when switching to the next version.
+#
+ifdef USE_KOBJCACHE
+ ifndef KBUILD_USE_KOBJCACHE
+  export KBUILD_USE_KOBJCACHE := $(USE_KOBJCACHE)
  endif
 endif
Index: /trunk/kBuild/tools/GCC3.kmk
===================================================================
--- /trunk/kBuild/tools/GCC3.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GCC3.kmk	(revision 1418)
@@ -105,5 +105,5 @@
 TOOL_GCC3_COMPILE_C_DEPEND =
 TOOL_GCC3_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC3_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GCC3_COMPILE_C_OUTPUT = $(outbase).i
@@ -121,5 +121,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC3_COMPILE_C_OUTPUT =
 define TOOL_GCC3_COMPILE_C_CMDS
@@ -130,5 +130,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -147,5 +147,5 @@
 TOOL_GCC3_COMPILE_CXX_DEPEND =
 TOOL_GCC3_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC3_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GCC3_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -163,5 +163,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC3_COMPILE_CXX_OUTPUT =
 define TOOL_GCC3_COMPILE_CXX_CMDS
@@ -172,5 +172,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GCC32.kmk
===================================================================
--- /trunk/kBuild/tools/GCC32.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GCC32.kmk	(revision 1418)
@@ -103,5 +103,5 @@
 TOOL_GCC32_COMPILE_C_DEPEND =
 TOOL_GCC32_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC32_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GCC32_COMPILE_C_OUTPUT = $(outbase).i
@@ -119,5 +119,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC32_COMPILE_C_OUTPUT =
 define TOOL_GCC32_COMPILE_C_CMDS
@@ -128,5 +128,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -145,5 +145,5 @@
 TOOL_GCC32_COMPILE_CXX_DEPEND =
 TOOL_GCC32_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC32_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GCC32_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -161,5 +161,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 
 TOOL_GCC32_COMPILE_CXX_OUTPUT =
@@ -171,5 +171,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GCC3OMF.kmk
===================================================================
--- /trunk/kBuild/tools/GCC3OMF.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GCC3OMF.kmk	(revision 1418)
@@ -95,5 +95,5 @@
 TOOL_GCC3OMF_COMPILE_C_DEPEND =
 TOOL_GCC3OMF_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC3OMF_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GCC3OMF_COMPILE_C_OUTPUT = $(outbase).i
@@ -111,5 +111,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC3OMF_COMPILE_C_OUTPUT =
 define TOOL_GCC3OMF_COMPILE_C_CMDS
@@ -120,5 +120,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -138,5 +138,5 @@
 TOOL_GCC3OMF_COMPILE_CXX_DEPEND =
 TOOL_GCC3OMF_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC3OMF_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GCC3OMF_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -154,5 +154,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC3OMF_COMPILE_CXX_OUTPUT =
 define TOOL_GCC3OMF_COMPILE_CXX_CMDS
@@ -163,5 +163,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GCC3PLAIN.kmk
===================================================================
--- /trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 1418)
@@ -101,5 +101,5 @@
 TOOL_GCC3PLAIN_COMPILE_C_DEPEND =
 TOOL_GCC3PLAIN_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC3PLAIN_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GCC3PLAIN_COMPILE_C_OUTPUT = $(outbase).i
@@ -117,5 +117,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC3PLAIN_COMPILE_C_OUTPUT =
 define TOOL_GCC3PLAIN_COMPILE_C_CMDS
@@ -126,5 +126,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -143,5 +143,5 @@
 TOOL_GCC3PLAIN_COMPILE_CXX_DEPEND =
 TOOL_GCC3PLAIN_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC3PLAIN_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GCC3PLAIN_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -159,5 +159,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC3PLAIN_COMPILE_CXX_OUTPUT =
 define TOOL_GCC3PLAIN_COMPILE_CXX_CMDS
@@ -168,5 +168,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GCC4MACHO.kmk
===================================================================
--- /trunk/kBuild/tools/GCC4MACHO.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GCC4MACHO.kmk	(revision 1418)
@@ -104,5 +104,5 @@
 TOOL_GCC4MACHO_COMPILE_C_DEPEND =
 TOOL_GCC4MACHO_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC4MACHO_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GCC4MACHO_COMPILE_C_OUTPUT = $(outbase).i
@@ -120,5 +120,5 @@
 		-
 endef
-else  # !USE_KOBJCACHE
+else  # !KBUILD_USE_KOBJCACHE
 TOOL_GCC4MACHO_COMPILE_C_OUTPUT =
 define TOOL_GCC4MACHO_COMPILE_C_CMDS
@@ -146,5 +146,5 @@
 TOOL_GCC4MACHO_COMPILE_CXX_DEPEND =
 TOOL_GCC4MACHO_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC4MACHO_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GCC4MACHO_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -162,5 +162,5 @@
 		-
 endef
-else  # !USE_KOBJCACHE
+else  # !KBUILD_USE_KOBJCACHE
 TOOL_GCC4MACHO_COMPILE_CXX_OUTPUT =
 define TOOL_GCC4MACHO_COMPILE_CXX_CMDS
@@ -171,5 +171,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -188,5 +188,5 @@
 TOOL_GCC4MACHO_COMPILE_OBJC_DEPEND =
 TOOL_GCC4MACHO_COMPILE_OBJC_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC4MACHO_COMPILE_OBJC_USES_KOBJCACHE = 1
 TOOL_GCC4MACHO_COMPILE_OBJC_OUTPUT = $(outbase).mi
@@ -204,5 +204,5 @@
 		-
 endef
-else  # !USE_KOBJCACHE
+else  # !KBUILD_USE_KOBJCACHE
 TOOL_GCC4MACHO_COMPILE_OBJC_OUTPUT =
 define TOOL_GCC4MACHO_COMPILE_OBJC_CMDS
@@ -213,5 +213,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GCC64.kmk
===================================================================
--- /trunk/kBuild/tools/GCC64.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GCC64.kmk	(revision 1418)
@@ -103,5 +103,5 @@
 TOOL_GCC64_COMPILE_C_DEPEND =
 TOOL_GCC64_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC64_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GCC64_COMPILE_C_OUTPUT = $(outbase).i
@@ -119,5 +119,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GCC64_COMPILE_C_OUTPUT =
 define TOOL_GCC64_COMPILE_C_CMDS
@@ -128,5 +128,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -145,5 +145,5 @@
 TOOL_GCC64_COMPILE_CXX_DEPEND =
 TOOL_GCC64_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GCC64_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GCC64_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -161,5 +161,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 
 TOOL_GCC64_COMPILE_CXX_OUTPUT =
@@ -171,5 +171,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GXX3.kmk
===================================================================
--- /trunk/kBuild/tools/GXX3.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GXX3.kmk	(revision 1418)
@@ -105,5 +105,5 @@
 TOOL_GXX3_COMPILE_C_DEPEND =
 TOOL_GXX3_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX3_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GXX3_COMPILE_C_OUTPUT = $(outbase).i
@@ -121,5 +121,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX3_COMPILE_C_OUTPUT =
 define TOOL_GXX3_COMPILE_C_CMDS
@@ -130,5 +130,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -147,5 +147,5 @@
 TOOL_GXX3_COMPILE_CXX_DEPEND =
 TOOL_GXX3_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX3_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GXX3_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -163,5 +163,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX3_COMPILE_CXX_OUTPUT =
 define TOOL_GXX3_COMPILE_CXX_CMDS
@@ -172,5 +172,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GXX32.kmk
===================================================================
--- /trunk/kBuild/tools/GXX32.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GXX32.kmk	(revision 1418)
@@ -103,5 +103,5 @@
 TOOL_GXX32_COMPILE_C_DEPEND =
 TOOL_GXX32_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX32_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GXX32_COMPILE_C_OUTPUT = $(outbase).i
@@ -119,5 +119,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX32_COMPILE_C_OUTPUT =
 define TOOL_GXX32_COMPILE_C_CMDS
@@ -128,5 +128,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -145,5 +145,5 @@
 TOOL_GXX32_COMPILE_CXX_DEPEND =
 TOOL_GXX32_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX32_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GXX32_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -161,5 +161,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX32_COMPILE_CXX_OUTPUT =
 define TOOL_GXX32_COMPILE_CXX_CMDS
@@ -170,5 +170,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GXX3OMF.kmk
===================================================================
--- /trunk/kBuild/tools/GXX3OMF.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GXX3OMF.kmk	(revision 1418)
@@ -95,5 +95,5 @@
 TOOL_GXX3OMF_COMPILE_C_DEPEND =
 TOOL_GXX3OMF_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX3OMF_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GXX3OMF_COMPILE_C_OUTPUT = $(outbase).i
@@ -111,5 +111,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX3OMF_COMPILE_C_OUTPUT =
 define TOOL_GXX3OMF_COMPILE_C_CMDS
@@ -120,5 +120,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -138,5 +138,5 @@
 TOOL_GXX3OMF_COMPILE_CXX_DEPEND =
 TOOL_GXX3OMF_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX3OMF_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GXX3OMF_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -154,5 +154,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX3OMF_COMPILE_CXX_OUTPUT =
 define TOOL_GXX3OMF_COMPILE_CXX_CMDS
@@ -163,5 +163,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GXX3PLAIN.kmk
===================================================================
--- /trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 1418)
@@ -101,5 +101,5 @@
 TOOL_GXX3PLAIN_COMPILE_C_DEPEND =
 TOOL_GXX3PLAIN_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX3PLAIN_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GXX3PLAIN_COMPILE_C_OUTPUT = $(outbase).i
@@ -117,5 +117,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX3PLAIN_COMPILE_C_OUTPUT =
 define TOOL_GXX3PLAIN_COMPILE_C_CMDS
@@ -126,5 +126,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -143,5 +143,5 @@
 TOOL_GXX3PLAIN_COMPILE_CXX_DEPEND =
 TOOL_GXX3PLAIN_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX3PLAIN_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GXX3PLAIN_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -159,5 +159,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX3PLAIN_COMPILE_CXX_OUTPUT =
 define TOOL_GXX3PLAIN_COMPILE_CXX_CMDS
@@ -168,5 +168,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/GXX4MACHO.kmk
===================================================================
--- /trunk/kBuild/tools/GXX4MACHO.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GXX4MACHO.kmk	(revision 1418)
@@ -104,5 +104,5 @@
 TOOL_GXX4MACHO_COMPILE_C_DEPEND =
 TOOL_GXX4MACHO_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX4MACHO_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GXX4MACHO_COMPILE_C_OUTPUT = $(outbase).i
@@ -120,5 +120,5 @@
 		-
 endef
-else  # !USE_KOBJCACHE
+else  # !KBUILD_USE_KOBJCACHE
 TOOL_GXX4MACHO_COMPILE_C_OUTPUT =
 define TOOL_GXX4MACHO_COMPILE_C_CMDS
@@ -146,5 +146,5 @@
 TOOL_GXX4MACHO_COMPILE_CXX_DEPEND =
 TOOL_GXX4MACHO_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX4MACHO_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GXX4MACHO_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -162,5 +162,5 @@
 		-
 endef
-else  # !USE_KOBJCACHE
+else  # !KBUILD_USE_KOBJCACHE
 TOOL_GXX4MACHO_COMPILE_CXX_OUTPUT =
 define TOOL_GXX4MACHO_COMPILE_CXX_CMDS
@@ -188,5 +188,5 @@
 TOOL_GXX4MACHO_COMPILE_OBJC_DEPEND =
 TOOL_GXX4MACHO_COMPILE_OBJC_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX4MACHO_COMPILE_OBJC_USES_KOBJCACHE = 1
 TOOL_GXX4MACHO_COMPILE_OBJC_OUTPUT = $(outbase).mi
@@ -204,5 +204,5 @@
 		-
 endef
-else  # !USE_KOBJCACHE
+else  # !KBUILD_USE_KOBJCACHE
 TOOL_GXX4MACHO_COMPILE_OBJC_OUTPUT =
 define TOOL_GXX4MACHO_COMPILE_OBJC_CMDS
Index: /trunk/kBuild/tools/GXX64.kmk
===================================================================
--- /trunk/kBuild/tools/GXX64.kmk	(revision 1417)
+++ /trunk/kBuild/tools/GXX64.kmk	(revision 1418)
@@ -103,5 +103,5 @@
 TOOL_GXX64_COMPILE_C_DEPEND =
 TOOL_GXX64_COMPILE_C_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX64_COMPILE_C_USES_KOBJCACHE = 1
 TOOL_GXX64_COMPILE_C_OUTPUT = $(outbase).i
@@ -119,5 +119,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX64_COMPILE_C_OUTPUT =
 define TOOL_GXX64_COMPILE_C_CMDS
@@ -128,5 +128,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -145,5 +145,5 @@
 TOOL_GXX64_COMPILE_CXX_DEPEND =
 TOOL_GXX64_COMPILE_CXX_DEPORD =
-ifdef USE_KOBJCACHE
+ifdef KBUILD_USE_KOBJCACHE
 TOOL_GXX64_COMPILE_CXX_USES_KOBJCACHE = 1
 TOOL_GXX64_COMPILE_CXX_OUTPUT = $(outbase).ii
@@ -161,5 +161,5 @@
 		-
 endef
-else # !USE_KOBJCACHE
+else # !KBUILD_USE_KOBJCACHE
 TOOL_GXX64_COMPILE_CXX_OUTPUT =
 define TOOL_GXX64_COMPILE_CXX_CMDS
@@ -170,5 +170,5 @@
 		$(abspath $(source))
 endef
-endif # !USE_KOBJCACHE
+endif # !KBUILD_USE_KOBJCACHE
 
 
Index: /trunk/kBuild/tools/VCC70.kmk
===================================================================
--- /trunk/kBuild/tools/VCC70.kmk	(revision 1417)
+++ /trunk/kBuild/tools/VCC70.kmk	(revision 1418)
@@ -114,5 +114,5 @@
 TOOL_VCC70_COMPILE_C_DEPEND =
 TOOL_VCC70_COMPILE_C_DEPORD =
-#ifdef USE_KOBJCACHE
+#ifdef KBUILD_USE_KOBJCACHE
 #TOOL_VCC70_COMPILE_C_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb) $(outbase).i
 #TOOL_VCC70_COMPILE_C_USESES_KOBJCACHE = 1
@@ -131,5 +131,5 @@
 #	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC70_PDB,$(outbase)-obj,idb)
 #endef
-#else # !USE_KOBJCACHE
+#else # !KBUILD_USE_KOBJCACHE
 TOOL_VCC70_COMPILE_C_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
 TOOL_VCC70_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb)
@@ -143,5 +143,5 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC70_PDB,$(outbase)-obj,idb)
 endef
-#endif # !USE_KOBJCACHE
+#endif # !KBUILD_USE_KOBJCACHE
 
 
@@ -162,5 +162,5 @@
 TOOL_VCC70_COMPILE_CXX_DEPEND =
 TOOL_VCC70_COMPILE_CXX_DEPORD =
-#ifdef USE_KOBJCACHE
+#ifdef KBUILD_USE_KOBJCACHE
 #TOOL_VCC70_COMPILE_CXX_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb) $(outbase).ii
 #TOOL_VCC70_COMPILE_CXX_USES_KOBJCACHE = 1
@@ -179,5 +179,5 @@
 #	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC70_PDB,$(outbase)-obj,idb)
 #endef
-#else # !USE_KOBJCACHE
+#else # !KBUILD_USE_KOBJCACHE
 TOOL_VCC70_COMPILE_CXX_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
 TOOL_VCC70_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb)
@@ -191,5 +191,5 @@
 	$(QUIET)$(DEP_IDB) -f -s -o $(dep) -t $(obj) $(call TOOL_VCC70_PDB,$(outbase)-obj,idb)
 endef
-#endif # !USE_KOBJCACHE
+#endif # !KBUILD_USE_KOBJCACHE
 
 