Index: /trunk/include/VBox/intnet.h
===================================================================
--- /trunk/include/VBox/intnet.h	(revision 1605)
+++ /trunk/include/VBox/intnet.h	(revision 1606)
@@ -215,5 +215,5 @@
     /** The size of the receive buffer. (input) */
     uint32_t        cbRecv;
-    /** check access? */
+    /** Whether new participants should be subjected to access check or not. */
     bool            fRestrictAccess;
     /** The handle to the network interface. (output) */
@@ -325,5 +325,11 @@
  *
  * @returns VBox status code.
- * @param   pIntNet     The
+ * @param   pIntNet         The internal network instance.
+ * @param   pSession        The session handle.
+ * @param   pszNetwork      The network name.
+ * @param   cbSend          The send buffer size.
+ * @param   cbRecv          The receive buffer size.
+ * @param   fRestrictAccess Whether new participants should be subjected to access check or not.
+ * @param   phIf            Where to store the handle to the network interface.
  */
 INTNETR0DECL(int) INTNETR0Open(PINTNET pIntNet, PSUPDRVSESSION pSession, const char *pszNetwork, unsigned cbSend, unsigned cbRecv, bool fRestrictAccess, PINTNETIFHANDLE phIf);
Index: /trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp
===================================================================
--- /trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 1605)
+++ /trunk/src/VBox/Devices/Network/SrvIntNetR0.cpp	(revision 1606)
@@ -1266,9 +1266,10 @@
  *
  * @returns VBox status code.
- * @param   pIntNet     The instance data.
- * @param   pszNetwork  The name of the network. This must be at least one character long and no longer
- *                      than the INTNETNETWORK::szName.
- * @param   pSession    The session handle.
- * @param   ppNetwork   Where to store the network.
+ * @param   pIntNet         The instance data.
+ * @param   pszNetwork      The name of the network. This must be at least one character long and no longer
+ *                          than the INTNETNETWORK::szName.
+ * @param   fRestrictAccess Whether new participants should be subjected to access check or not.
+ * @param   pSession        The session handle.
+ * @param   ppNetwork       Where to store the network.
  */
 static int INTNETCreateNetwork(PINTNET pIntNet, PSUPDRVSESSION pSession, const char *pszNetwork, bool fRestrictAccess, PINTNETNETWORK *ppNetwork)
@@ -1294,5 +1295,5 @@
         {
             RTSpinlockRelease(pIntNet->Spinlock, &Tmp);
-            LogFlow(("INTNETOpenNetwork: returns VERR_ALREADY_EXISTS\n"));
+            LogFlow(("INTNETCreateNetwork: returns VERR_ALREADY_EXISTS\n"));
             return VERR_ALREADY_EXISTS;
         }
@@ -1339,5 +1340,5 @@
             {
                 *ppNetwork = pNew;
-                LogFlow(("INTNETOpenNetwork: returns VINF_SUCCESS *ppNetwork=%p\n", pNew));
+                LogFlow(("INTNETCreateNetwork: returns VINF_SUCCESS *ppNetwork=%p\n", pNew));
                 return VINF_SUCCESS;
             }
@@ -1345,5 +1346,5 @@
             /* The release will destroy the object. */
             SUPR0ObjRelease(pNew->pvObj, pSession);
-            LogFlow(("INTNETOpenNetwork: returns %Vrc\n", rc));
+            LogFlow(("INTNETCreateNetwork: returns %Vrc\n", rc));
             return rc;
         }
@@ -1354,5 +1355,5 @@
     }
     RTMemFree(pNew);
-    LogFlow(("INTNETOpenNetwork: returns %Vrc\n", rc));
+    LogFlow(("INTNETCreateNetwork: returns %Vrc\n", rc));
     return rc;
 }
@@ -1363,10 +1364,11 @@
  *
  * @returns VBox status code.
- * @param   pIntNet     The internal network instance.
- * @param   pSession    The session handle.
- * @param   pszNetwork  The network name.
- * @param   cbSend      The send buffer size.
- * @param   cbRecv      The receive buffer size.
- * @param   phIf        Where to store the handle to the network interface.
+ * @param   pIntNet         The internal network instance.
+ * @param   pSession        The session handle.
+ * @param   pszNetwork      The network name.
+ * @param   cbSend          The send buffer size.
+ * @param   cbRecv          The receive buffer size.
+ * @param   fRestrictAccess Whether new participants should be subjected to access check or not.
+ * @param   phIf            Where to store the handle to the network interface.
  */
 INTNETR0DECL(int) INTNETR0Open(PINTNET pIntNet, PSUPDRVSESSION pSession, const char *pszNetwork, unsigned cbSend, unsigned cbRecv, bool fRestrictAccess, PINTNETIFHANDLE phIf)